#include "header.h"
#define FLAVOR 0
#include "common.h"

/**
 * Basic checks for thread make and assigning IDs.
 */

#define C1 42
#define C2 0x12345678abcdefabUL
#define C3 012345670123456701234UL
 
void t1(void* arg);
void t2(void* arg);
void t3(void* arg);
void t4(void* arg);
 
int main(){
    printf("01_ids_make:     ");
    fflush(0);
    thread_init();
 
    int id1 = thread_make(t1, (void*)(intptr_t)C1);
    int id2 = thread_make(t2, (void*)(intptr_t)C2);
 
    int myid = thread_myid();
    
    assertVerbose(myid==0, "main thread id should be 0, and is %d", myid);
    assertVerbose(id1==1, "threads should get consecutive ids, expected: 1 got: %d", id1);
    assertVerbose(id2==2, "threads should get consecutive ids, expected: 2 got: %d", id2);
    
    wait_state(1);
 
    int id4 = thread_make(t4, NULL);
    
    assert(id4==4);
    
    usleep(50000);
    
    puts("ok");
    
    return 0;
}
 
void t1(void* arg){
    assertVerbose((intptr_t)arg==C1, "argument from thread_make has not been passed correctly to thread routine");
    int myid = thread_myid();
    assertVerbose(myid==1, "t1 thread_myid() is %d", myid);
    thread_term();
}
 
void t2(void* arg){
    assertVerbose((intptr_t)arg==C2, "argument from thread_make has not been passed correctly to thread routine");
    int myid = thread_myid();
    assertVerbose(myid==2, "t2 thread_myid() is %d", myid);
    int id = thread_make(t3, (void*)(intptr_t)C3);
    assertVerbose(id==3, "threads should get consecutive ids, expected: 3 got: %d", id);
    adv_state(1);
}

void t3(void* arg){
    assertVerbose((intptr_t)arg==C3, "argument from thread_make has not been passed correctly to thread routine");
    int myid = thread_myid();
    assertVerbose(myid==3, "t3 thread_myid() is %d", myid);
}

void t4(void* arg){
    assertVerbose(arg==NULL, "argument from thread_make has not been passed correctly to thread routine");
    int myid = thread_myid();
    assertVerbose(myid==4, "t4 thread_myid() is %d", myid);
}



