#include "header.h"
#define FLAVOR 0
#include "common.h"

/**
 * Basic checks for send and receive.
 */

thread_msg * msg1, *msg2, *msg3;
void t1(void* _){
    int id;
    thread_msg * m;
    
    wait_state(1);
    thread_receive(&id, &m);
    assertVerbose(id==0 && m==msg1, "receiving msg1 failed, id%d, m%p msg1%p", id, m, msg1);
    thread_msg_dec_use_count(m);
    
    thread_receive(&id, &m);
    assertVerbose(id==0 && m==msg2, "receiving msg2 failed, id%d, m%p msg2%p", id, m, msg2);
    thread_msg_dec_use_count(m);
    
    msg3 = thread_msg_make("third");
    int rv = thread_send(0, msg3);
    assertVerbose(rv==0, "send msg3 failed");
    
    adv_state(2);
    
    thread_term();
}

int main(){
    printf("02_send_receive: ");
    fflush(0);
    thread_init();
 
    thread_make(t1, NULL);
    
    msg1 = thread_msg_make("contents");
    int rv = thread_send(2, msg1);
    assertVerbose(rv==-1 && errno==ESRCH, "bad errno%d/return value%d upon sending to a ID that does not exist yet", errno, rv);
    errno=0;
    
    rv = thread_send(1, msg1);
    assertVerbose(rv==0, "send msg1 failed");
    
    adv_state(1);
    
    msg2 = thread_msg_make("another");
    rv = thread_send(1, msg2);
    assertVerbose(rv==0, "send msg2 failed");
    
    int id;
    thread_msg * m;
    thread_receive(&id, &m);
    assertVerbose(id==1 && m==msg3, "receiving msg3 failed, id%d, m%p msg3%p", id, m, msg3);
    
    wait_state(2);
    usleep(50000);
    
    rv = thread_send(1, msg1);
    assertVerbose(rv==-1 && errno==ESRCH, "bad errno%d/return value%d upon sending to a ID that is no more", errno, rv);
    errno=0;
    thread_msg_dec_use_count(m);
    
    puts("ok");
    
    return 0;
}
