#include "header.h"
#define FLAVOR 0
#include "common.h"

/**
 * Send should wait until queue is not full.
 * Receive should wake blocked send.
 */

void t1(void* _){
    int id;
    thread_msg * m;
    usleep(125000);
    for(int i = 0 ; i < 10 ; ++i){
        thread_receive(&id, &m);
        thread_msg_dec_use_count(m);
    }
}

int main(){
    printf("03_queue_size1:  ");
    fflush(0);
    thread_init();
 
    int id = thread_make(t1, NULL);
    
    elapsed();
    for(int i = 0 ; i < 10 ; ++i){
        thread_send(id, thread_msg_make("contents"));
        long ms = elapsed();
        assertVerbose((i==THREAD_MSGQUEUE_SIZE && ms>100000) || (i!=THREAD_MSGQUEUE_SIZE && ms<25000),
                      "sending %d took %ld", i, ms);
    }
    
    usleep(50000);
    puts("ok");
    
    return 0;
}
