#include "header.h"
#define FLAVOR 0
#include "common.h"

/**
 * Send must cancel if the target thread terminates.
 * Messages in queue must be freed upon term.
 */

void t(void * arg){
    usleep(125000);
    if(arg)
        thread_term();
}
 
int main(){
    printf("05_send_cancel:  ");
    fflush(0);
    thread_init();
 
    int id;
    thread_msg *sampleMessage = NULL;
    
    for(intptr_t i = 1; i >=0; --i){
        id = thread_make(t, (void*)i);
        
        for(int i = 0 ; i < 10 ; ++i){
            thread_msg *m = thread_msg_make("contents");
            if(sampleMessage == NULL){
                sampleMessage = m;
                thread_msg_inc_use_count(sampleMessage);
            }
            
            int rv = thread_send(id, m);
            if(rv)
                thread_msg_dec_use_count(m);
            if(i == THREAD_MSGQUEUE_SIZE)
                assertVerbose(rv==-1 && errno==ECANCELED, "errno not set to ECANCELED when waiting on full queue and recepient terminated");
            if(i > THREAD_MSGQUEUE_SIZE)
                assertVerbose(rv==-1 && errno==ESRCH, "errno not set to ESRCH when receiver terminated before send");
        }
    }
    
    assertVerbose(sampleMessage->uc==1, "message from queue of terminating thread has not been thread_msg_dec_use_count'd");
    thread_msg_dec_use_count(sampleMessage);
    
    usleep(50000);
    puts("ok");
    return 0;
}
