#include "header.h"
#define FLAVOR 0
#include "common.h"

/**
 * Basic checks for multicast
 */
 
void t(void* arg);
void d(void* arg);
void s(void* arg);
void k(void* arg);

int sid;
thread_msg* msg;

int main(){
    printf("07_mcast:        ");
    fflush(0);
    thread_init();
 
    int *ids = malloc(sizeof(int*)*6);
    ids[0] = 5;
    ids[1] = -99;
    ids[2] = thread_make(t, NULL);
    int kid= thread_make(k, NULL);
    ids[3] = thread_make(t, NULL);
    ids[4] = thread_make(d, NULL);
    ids[5] = thread_make(t, NULL);    
    sid    = thread_make(s, ids);
    
    adv_state(1);
    
    // block own queue
    thread_msg *placeholder = thread_msg_make("foo");
    for(int i = 0 ; i < THREAD_MSGQUEUE_SIZE; ++i){
        int rv = thread_send(0, placeholder);
        assertVerbose(rv==0, "sending to self failed");
    }
    
    adv_state(2);
    for(int i = 0 ; i < THREAD_MSGQUEUE_SIZE; ++i){
        int id;
        thread_msg * m;
        thread_receive(&id, &m);
        assertVerbose(m==placeholder, "did not receive message sent to self - wrong msg");
        assertVerbose(id==0, "did not receive message sent to self - wrong id");
    }
    thread_msg_dec_use_count(placeholder);
    
    for(int i = 0 ; i < 3; ++i){
        int id;
        thread_msg * m;
        thread_receive(&id, &m);
        assertVerbose(atoi(m->txt)==id, "wrong message in main, expected %d got %d", id, atoi(m->txt));
        thread_msg_dec_use_count(m);
    }
    
    thread_send(kid, thread_msg_make(NULL));
    
    usleep(50000);
    puts("ok");
    return 0;
}

void s(void *arg){
    int * tgts = (int *)arg;
    msg = thread_msg_make("mcast");
    
    wait_state(1);
    usleep(50000); // d shall die    
    int count = thread_mcast(tgts+1, tgts[0], msg);
    assertVerbose(count==3, "Wrong return value of mcast - %d", count);
    assertVerbose(msg->uc==3, "Use count set to wrong value - %d", msg->uc);
    thread_msg_dec_use_count(msg);
    thread_msg_dec_use_count(msg);
    thread_msg_dec_use_count(msg);
    free(arg);
}

void t(void *_){
    int id;
    thread_msg * m;
    thread_receive(&id, &m);
    assertVerbose(id==sid, "wrong message in t, expected id %d got %d", sid, id);
    assertVerbose(m==msg, "wrong message in t, expected msg %p got %p", m, msg);
    
    
    char myid[8];
    sprintf(myid, "%d", thread_myid());
    thread_msg *idMsg = thread_msg_make(myid);
    int tgt=0;
    
    wait_state(2);
    int count = thread_mcast(&tgt, 1, idMsg);
    assertVerbose(count==1, "mcast should sent to 1 thread, sent to %d", count);
}

void d(void*_){
    /*dummy do-nothing thread*/
}

void k(void*_){
    int id;
    thread_msg * m;
    thread_receive(&id, &m);
    assertVerbose(m->txt==NULL, "k got an extra message, %p with text %s from %d", m, m->txt, id);
    assertVerbose(id==0, "k got message from wrong sender %d", id);
    thread_msg_dec_use_count(m);
    thread_term();
}
