#include "header.h"
#define FLAVOR 1
#include "common.h"

/**
 * Gathering from more threads than there are in the queue
 */

int gid;
void g(void*_){
    int ids[10];
    thread_msg* msgs[10];
    
    wait_state(1);
    
    for(int i = 0 ; i < 10; ++i)
        ids[i]=i+1;
    // sent inc, gathered inc
    int rv = thread_gather(ids, 10, msgs);
    assert(rv==10);
    for(int i = 0 ; i < 10; ++i){
        assert(msgs[i]->num==(i+1)+00);
        thread_msg_dec_use_count(msgs[i]);
        ids[i]=10-i;
    }
    // sent inc, gathered dec
    rv = thread_gather(ids, 10, msgs);
    assert(rv==10);
    for(int i = 0 ; i < 10; ++i){
        assert(msgs[i]->num==(10-i)+10);
        thread_msg_dec_use_count(msgs[i]);
        ids[i]=i+1;
    }
    // sent dec, gathered inc
    rv = thread_gather(ids, 10, msgs);
    assert(rv==10);
    for(int i = 0 ; i < 10; ++i){
        assert(msgs[i]->num==(i+1)+20);
        thread_msg_dec_use_count(msgs[i]);
        ids[i]=10-i;
    }
    // sent dec, gathered dec
    rv = thread_gather(ids, 10, msgs);
    assert(rv==10);
    for(int i = 0 ; i < 10; ++i){
        assert(msgs[i]->num==(10-i)+30);
        thread_msg_dec_use_count(msgs[i]);
        ids[i]=i+1;
    }
    
    wait_state(41);
    adv_state(42);
}

void t(void*_){
    wait_state( 0+thread_myid());
    thread_send(gid, thread_msg_make(thread_myid()+00));
    adv_state(  1+thread_myid());
    
    wait_state(10+thread_myid());
    thread_send(gid, thread_msg_make(thread_myid()+10));
    adv_state( 11+thread_myid());
    
    wait_state(31-thread_myid());
    thread_send(gid, thread_msg_make(thread_myid()+20));
    adv_state( 32-thread_myid());
    
    wait_state(41-thread_myid());
    thread_send(gid, thread_msg_make(thread_myid()+30));
    adv_state( 42-thread_myid());
}


int main(){
    printf("09_gather_many:  ");
    fflush(0);
    thread_init();
 
    for(int i = 1 ; i <= 10; ++i)
        thread_make(t, NULL);
    
    gid = thread_make(g, NULL);
    
    adv_state(1);
    
    wait_state(42);
    
    usleep(50000);
    puts("ok");
    return 0;
}

