#include "header.h"
#define FLAVOR 1
#include "common.h"

/**
 * Multicasting or gathering multiple times to/from one thread in a single call
 */

void a(void*_){
    int id;
    thread_msg * msgs[3];
    thread_receive(&id, &msgs[0]);
    thread_receive(&id, &msgs[1]);
    thread_receive(&id, &msgs[2]);
    assertVerbose(msgs[0]==msgs[1] && msgs[0]==msgs[2] && msgs[0]->num==1, "'a' should get the same message 3 times");
    thread_msg_dec_use_count(msgs[0]);
    thread_msg_dec_use_count(msgs[1]);
    thread_msg_dec_use_count(msgs[2]);
    
    thread_send(0, thread_msg_make(2));
}

void b(void*_){
    int id;
    thread_msg * msgs[3];
    thread_receive(&id, &msgs[0]);
    thread_receive(&id, &msgs[1]);
    thread_receive(&id, &msgs[2]);
    assertVerbose(msgs[0]==msgs[1] && msgs[0]==msgs[2] && msgs[0]->num==1, "'b' should get the same message 3 times");
    thread_msg_dec_use_count(msgs[0]);
    thread_msg_dec_use_count(msgs[1]);
    thread_msg_dec_use_count(msgs[2]);

    thread_send(0, thread_msg_make(3));
    thread_send(0, thread_msg_make(4));
    thread_send(0, thread_msg_make(5));
}


int main(){
    printf("10_multiples:    ");
    fflush(0);
    thread_init();
 
    int A = thread_make(a, NULL);
    int B = thread_make(b, NULL);
    
    int ids[]={A,A,B,B,A,B};
    thread_msg *msg = thread_msg_make(1);
    int rv = thread_mcast(ids, 6, msg);
    assertVerbose(rv==6, "Should send 6 messages, sent %d", rv);

    ids[4]=5;
    thread_msg *msgs[6]; 
    rv = thread_gather(ids, 6, msgs);
    assertVerbose(rv==4, "Should receive 4 messages, got %d (%p %p %p %p %p %p)", rv, msgs[0], msgs[1], msgs[2], msgs[3], msgs[4], msgs[5]);
    assert(msgs[0]->num==2);  thread_msg_dec_use_count(msgs[0]);
    assert(msgs[1]==NULL);
    assert(msgs[2]->num==3);  thread_msg_dec_use_count(msgs[2]);
    assert(msgs[3]->num==4);  thread_msg_dec_use_count(msgs[3]);
    assert(msgs[4]==NULL);
    assert(msgs[5]->num==5);  thread_msg_dec_use_count(msgs[5]);
    
    usleep(50000);
    puts("ok");
    return 0;
}
