#include "header.h"
#define FLAVOR 1
#include "common.h"

/**
 * checking if gather that takes a message from the queue disrupts queue order
 */

void a(void*_){
    thread_send(0, thread_msg_make(1));
    adv_state(1);
    
    wait_state(3);
    thread_send(0, thread_msg_make(4));
    adv_state(4);
}

void b(void*_){
    wait_state(1);
    thread_send(0, thread_msg_make(2));
    adv_state(2);
    
    wait_state(4);
    thread_send(0, thread_msg_make(5));
    adv_state(5);
}

void c(void*_){
    wait_state(2);
    thread_send(0, thread_msg_make(3));
    adv_state(3);
    
    wait_state(5);
    thread_send(0, thread_msg_make(6));
    adv_state(6);
    
}

int main(){
    printf("11_order:        ");
    fflush(0);
    thread_init();
 
    int aid = thread_make(a, NULL);
    int bid = thread_make(b, NULL);
    int cid = thread_make(c, NULL);
    
    wait_state(3);
    int id = 2;
    thread_msg *m;
    int rv = thread_gather(&id, 1, &m);
    assertVerbose(rv==1 && m->num==2, "first gather (from 1) got msg num %d and returned %d, while should get 2", m->num, rv);
    thread_msg_dec_use_count(m);
    
    thread_receive(&id, &m);
    assertVerbose(id==aid && m->num==1, "first receive got msg num %d from %d, should get 1 from %d", m->num, id, aid);
    thread_msg_dec_use_count(m);
    
    thread_receive(&id, &m);
    assertVerbose(id==cid && m->num==3, "second receive got msg num %d from %d, should get 3 from %d", m->num, id, aid);
    thread_msg_dec_use_count(m);
    
    id = 3;
    rv = thread_gather(&id, 1, &m);
    assertVerbose(rv==1 && m->num==6, "second gather (from 3) got msg num %d and returned %d, while should get 6", m->num, rv);
    thread_msg_dec_use_count(m);
    
    thread_receive(&id, &m);
    assertVerbose(id==aid && m->num==4, "third receive got msg num %d from %d, should get 4 from %d", m->num, id, aid);
    thread_msg_dec_use_count(m);
    
    thread_receive(&id, &m);
    assertVerbose(id==bid && m->num==5, "fourth receive got msg num %d from %d, should get 5 from %d", m->num, id, aid);
    thread_msg_dec_use_count(m);
    
    usleep(50000);
    
    puts("ok");
    return 0;
}
